

function createButton( element, label, callback ) {
    element.style.appleDashboardRegion = "dashboard-region(control rectangle)";
    element.style.height = "16px;";

    var left = document.createElement( "div" );
    left.setAttribute( "style", "position:absolute;top:0px;left:0px;width:4px;height:16px;background:url(Images/ButtonLeft.png) top left;" );
    element.appendChild( left );
    var center = document.createElement( "div" );
    center.setAttribute( "style", "position:absolute;top:0px;left:4px;right:4px;bottom:0px;line-height:16px;background:url(Images/ButtonMiddle.png) repeat-x top left;text-align:center;color.white;" );
    center.appendChild( document.createTextNode( label ) );
    element.appendChild( center );
    var right = document.createElement( "div" );
    right.setAttribute( "style", "position:absolute;top:0px;right:0px;width:4px;height:16px;background:url(Images/ButtonRight.png);" );
    element.appendChild( right );

    element.style.background = "none";
    element.callback = callback;
    element.pushableButton = true;
    element.enabled = true;
    element.addEventListener( "click", "debug('click')" );
    element.setAttribute( "onmousedown", "debug('event');buttonDown(event,this);", true );
    (new Image()).src = "Images/ButtonLeft2.png";
    (new Image()).src = "Images/ButtonMiddle2.png";
    (new Image()).src = "Images/ButtonRight2.png";
}

function buttonDown( event, elem ) {
    //debug( "pushed " + event + " " + elem );//+ " " + elem.callback);
    if ( elem.pushableButton ) {
        var children = elem.childNodes;
        children[ 0 ].style.background ="url(Images/ButtonLeft2.png)";
        children[ 1 ].style.background ="url(Images/ButtonMiddle2.png) repeat-x";
        children[ 2 ].style.background ="url(Images/ButtonRight2.png);";
        children[ 1 ].style.color = "#ddd";
        elem.setAttribute( "onmouseup", "buttonUp(event,this);" );
        elem.setAttribute( "onmouseout", "buttonOut(event,this);" );
    }
}
function buttonOut( event, elem ) {
    //debug( "out " + event + " " + elem );
    if ( elem.pushableButton ) {
        var children = elem.childNodes;
        children[ 0 ].style.background ="url(Images/ButtonLeft.png)";
        children[ 1 ].style.background ="url(Images/ButtonMiddle.png) repeat-x";
        children[ 2 ].style.background ="url(Images/ButtonRight.png);";
        children[ 1 ].style.color = "white";
        elem.removeAttribute( "onmouseup" );
        elem.removeAttribute( "onmouseout" );
    }
}
function buttonUp( event, elem ) {
    buttonOut( event, elem );
    if ( elem.pushableButton ) {
        elem.callback( event, elem );
    }
}

